
#include <string.h>
        
uint8 get_id3_tag(const uint8* fname,uint8* buftag)
        {
        uint32 id3v2_tag_size;
        uint32 tag_header_size;
        uint8  id3tag[64];
        uint8  id3cmd[10];
        uint16 i; 
        uint8 res;
        FIL fil;
        UINT br;
         
        strcpy(buftag,";-) FileName : "); 
        strcat(buftag,fname);                          
        if (f_open(&fil,fname,FA_READ) != FR_OK) return 1;                                                         
        res = f_read(&fil,id3cmd, 10, &br);     
        if (res == FR_OK && (strncmpf (id3cmd, "ID3", 3) == 0) && (id3cmd[3] >= 3))
                {
                id3v2_tag_size = (id3cmd[9] & 0x7f) + ((id3cmd[8] & 0x7f) << 7) + ((id3cmd[7] & 0x7f) << 14) + ((id3cmd[6] & 0x7f) << 21);  
                tag_header_size = 0;
                for(i=10;i<id3v2_tag_size;)
                        {
                        res = f_read(&fil,id3cmd, 10, &br);
                        tag_header_size = (id3cmd[7] & 0x7f) + ((id3cmd[6] & 0x7f) << 7) + ((id3cmd[5] & 0x7f) << 14) + ((id3cmd[4] & 0x7f) << 21);
                        i = i + tag_header_size + 10;
                        res = f_read(&fil,id3tag, tag_header_size, &br);
                        if(tag_header_size > 64)tag_header_size = 64;
                        if (res == FR_OK && br > 0)                                              
                                {
                                id3tag[0] = ' ';
                                if (strncmpf(id3cmd, "TALB", 4) == 0) 
                                        { 
                                        strcat(buftag," -- Title :");
                                        strcat(buftag,id3tag); 
                                        }
                                else if (strncmpf(id3cmd, "TIT2", 4) == 0)
                                        { 
                                        strcat(buftag," -- Artist :");
                                        strcat(buftag,id3tag); 
                                        }
                                else if (strncmpf(id3cmd, "TPE1", 4) == 0)
                                        { 
                                        strcat(buftag," -- Album :");
                                        strcat(buftag,id3tag);
                                        }
                                }
                        }
                return res;
                }
             
        if (f_lseek(&fil,fil.fsize - 128)!= FR_OK)return 1; 
        res = f_read(&fil,id3cmd, 3, &br);
        if ((res == FR_OK) && (strncmpf(id3cmd, "TAG", 3) == 0))            
                {
                f_read(&fil,id3tag, 30, &br);
                if(id3tag != '\0')
                        {
                        strcat(buftag," -- Title = ");
                        strcat(buftag,id3tag);
                        }
                f_read(&fil,id3tag, 30, &br);
                if(id3tag != '\0')
                        {
                        strcat(buftag," -- Artist = ");
                        strcat(buftag,id3tag);
                        }
                f_read(&fil,id3tag, 30, &br);
                if(id3tag != '\0')
                        {
                        strcat(buftag," -- Album = ");
                        strcat(buftag,id3tag);
                        } 
                return res;
                } 
        return res; 
        }