/*
flash unsigned char shmtable[6][12]={
        {11,10,10,9,9,9,8,9,9,10,11,9       },
        {20,20,21,21,22,22,22,22,21,21,20,19},
        {11,10,10,9,9,9,8,9,9,10,11,10      },
        {20,20,21,21,22,22,22,22,21,21,20,19},
        {12,11,11,10,10,10,9,10,10,11,12,10 },
        {19,19,20,20,21,21,21,21,20,20,19,18}};
*/
flash unsigned char miltable[6][12]={
        {20,19,19,19,20,20,21,21,21,21,20,20},
        {10,11,10,12,11,11,10,10,10,9,10,10 },
        {19,18,20,20,21,21,22,22,22,22,21,21},
        {11,12,10,11,10,10,9,9,9,8,9,9      },
        {20,19,20,20,21,21,22,22,22,22,21,21},
        {10,11,9,11,10,10,9,9,9,8,9,9       }};

//------------------- Tabdil tarikh miladi be shamsi -------------------------
void miltoshmcv(RTC *rtc)
        {
        //unsigned char ym,mm,dm;
        unsigned char k,t1,t2;
        rtc->year -= 2000; 
        k = rtc->year % 4;
        if(k == 3) k = 2;
        k *= 2;
        t1 = miltable[k][rtc->month - 1];
        t2 = miltable[k + 1][rtc->month - 1];
        if(rtc->month < 3 || (rtc->month == 3 && rtc->mday <= miltable[k][rtc->month - 1]))
                rtc->year += 1378;
        else
                rtc->year += 1379;
        if(rtc->mday <= t1)
                {
                rtc->mday += t2;
                rtc->month = (rtc->month + 8) % 12 + 1;
                }
        else
                {
                rtc->mday -= t1;
                rtc->month = (rtc->month + 9) % 12 + 1;
                }
        }

//------------------- Tabdil tarikh shamsi be miladi -------------------------
/*
void shmtomilcv(RTC *rtc)
        {
        unsigned char k,t1,t2;
        rtc->year -= 1300;
        k = rtc->year % 4;
        if(k == 0) k = 2; else k = k + k;
        t1 = shmtable[k - 2][rtc->month - 1];
        t2 = shmtable[k - 1][rtc->month - 1];
        if(rtc->month < 10 || (rtc->month == 10 && rtc->mday <= shmtable[k - 2][rtc->month - 1]))
                rtc->year += 1921;
        else
                rtc->year += 1922;
        if(rtc->mday <= t1)
                {
                rtc->mday += t2;
                rtc->month = (rtc->month + 1) % 12 + 1;
                }
        else
                {
                rtc->mday -= t1;
                rtc->month = (rtc->month + 2) % 12 + 1;
                }
        }
*/